/* query.c generated by valac 0.46.6, the Vala compiler
 * generated from query.vala, do not modify */

/*
 * Copyright (C) 2010 Michal Hruby <michal.mhr@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Michal Hruby <michal.mhr@gmail.com>
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>

typedef enum  {
	SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE = 1 << 0,
	SYNAPSE_QUERY_FLAGS_UNCATEGORIZED = 1 << 1,
	SYNAPSE_QUERY_FLAGS_APPLICATIONS = 1 << 2,
	SYNAPSE_QUERY_FLAGS_ACTIONS = 1 << 3,
	SYNAPSE_QUERY_FLAGS_AUDIO = 1 << 4,
	SYNAPSE_QUERY_FLAGS_VIDEO = 1 << 5,
	SYNAPSE_QUERY_FLAGS_DOCUMENTS = 1 << 6,
	SYNAPSE_QUERY_FLAGS_IMAGES = 1 << 7,
	SYNAPSE_QUERY_FLAGS_FILES = ((SYNAPSE_QUERY_FLAGS_AUDIO | SYNAPSE_QUERY_FLAGS_VIDEO) | SYNAPSE_QUERY_FLAGS_DOCUMENTS) | SYNAPSE_QUERY_FLAGS_IMAGES,
	SYNAPSE_QUERY_FLAGS_PLACES = 1 << 8,
	SYNAPSE_QUERY_FLAGS_INTERNET = 1 << 9,
	SYNAPSE_QUERY_FLAGS_TEXT = 1 << 10,
	SYNAPSE_QUERY_FLAGS_CONTACTS = 1 << 11,
	SYNAPSE_QUERY_FLAGS_ALL = 0xFFFFFFFFLL,
	SYNAPSE_QUERY_FLAGS_LOCAL_CONTENT = SYNAPSE_QUERY_FLAGS_ALL ^ SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE
} SynapseQueryFlags;

#define SYNAPSE_TYPE_QUERY_FLAGS (synapse_query_flags_get_type ())
typedef enum  {
	SYNAPSE_MATCHER_FLAGS_NO_REVERSED = 1 << 0,
	SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING = 1 << 1,
	SYNAPSE_MATCHER_FLAGS_NO_PARTIAL = 1 << 2,
	SYNAPSE_MATCHER_FLAGS_NO_FUZZY = 1 << 3
} SynapseMatcherFlags;

#define SYNAPSE_TYPE_MATCHER_FLAGS (synapse_matcher_flags_get_type ())

#define SYNAPSE_TYPE_QUERY (synapse_query_get_type ())
typedef struct _SynapseQuery SynapseQuery;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef enum  {
	SYNAPSE_MATCH_SCORE_INCREMENT_MINOR = 2000,
	SYNAPSE_MATCH_SCORE_INCREMENT_SMALL = 5000,
	SYNAPSE_MATCH_SCORE_INCREMENT_MEDIUM = 10000,
	SYNAPSE_MATCH_SCORE_INCREMENT_LARGE = 20000,
	SYNAPSE_MATCH_SCORE_URI_PENALTY = 15000,
	SYNAPSE_MATCH_SCORE_POOR = 50000,
	SYNAPSE_MATCH_SCORE_BELOW_AVERAGE = 60000,
	SYNAPSE_MATCH_SCORE_AVERAGE = 70000,
	SYNAPSE_MATCH_SCORE_ABOVE_AVERAGE = 75000,
	SYNAPSE_MATCH_SCORE_GOOD = 80000,
	SYNAPSE_MATCH_SCORE_VERY_GOOD = 85000,
	SYNAPSE_MATCH_SCORE_EXCELLENT = 90000,
	SYNAPSE_MATCH_SCORE_HIGHEST = 100000
} SynapseMatchScore;

#define SYNAPSE_TYPE_MATCH_SCORE (synapse_match_score_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SynapseQuery {
	gchar* query_string;
	gchar* query_string_folded;
	GCancellable* cancellable;
	SynapseQueryFlags query_type;
	guint max_results;
	guint query_id;
};

typedef enum  {
	SYNAPSE_SEARCH_ERROR_SEARCH_CANCELLED,
	SYNAPSE_SEARCH_ERROR_UNKNOWN_ERROR
} SynapseSearchError;
#define SYNAPSE_SEARCH_ERROR synapse_search_error_quark ()

GType synapse_query_flags_get_type (void) G_GNUC_CONST;
GType synapse_matcher_flags_get_type (void) G_GNUC_CONST;
GType synapse_query_get_type (void) G_GNUC_CONST;
SynapseQuery* synapse_query_dup (const SynapseQuery* self);
void synapse_query_free (SynapseQuery* self);
void synapse_query_copy (const SynapseQuery* self,
                         SynapseQuery* dest);
void synapse_query_destroy (SynapseQuery* self);
void synapse_query_init (SynapseQuery *self,
                         guint query_id,
                         const gchar* query,
                         SynapseQueryFlags flags,
                         guint num_results);
gboolean synapse_query_is_cancelled (SynapseQuery *self);
GQuark synapse_search_error_quark (void);
void synapse_query_check_cancellable (SynapseQuery *self,
                                      GError** error);
GeeList* synapse_query_get_matchers_for_query (const gchar* query,
                                               SynapseMatcherFlags match_flags,
                                               GRegexCompileFlags flags);
GType synapse_match_score_get_type (void) G_GNUC_CONST;
static void _vala_array_add6 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static gint __lambda5_ (GeeMapEntry* a,
                 GeeMapEntry* b);
static gint ___lambda5__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

GType
synapse_query_flags_get_type (void)
{
	static volatile gsize synapse_query_flags_type_id__volatile = 0;
	if (g_once_init_enter (&synapse_query_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE, "SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE", "include-remote"}, {SYNAPSE_QUERY_FLAGS_UNCATEGORIZED, "SYNAPSE_QUERY_FLAGS_UNCATEGORIZED", "uncategorized"}, {SYNAPSE_QUERY_FLAGS_APPLICATIONS, "SYNAPSE_QUERY_FLAGS_APPLICATIONS", "applications"}, {SYNAPSE_QUERY_FLAGS_ACTIONS, "SYNAPSE_QUERY_FLAGS_ACTIONS", "actions"}, {SYNAPSE_QUERY_FLAGS_AUDIO, "SYNAPSE_QUERY_FLAGS_AUDIO", "audio"}, {SYNAPSE_QUERY_FLAGS_VIDEO, "SYNAPSE_QUERY_FLAGS_VIDEO", "video"}, {SYNAPSE_QUERY_FLAGS_DOCUMENTS, "SYNAPSE_QUERY_FLAGS_DOCUMENTS", "documents"}, {SYNAPSE_QUERY_FLAGS_IMAGES, "SYNAPSE_QUERY_FLAGS_IMAGES", "images"}, {SYNAPSE_QUERY_FLAGS_FILES, "SYNAPSE_QUERY_FLAGS_FILES", "files"}, {SYNAPSE_QUERY_FLAGS_PLACES, "SYNAPSE_QUERY_FLAGS_PLACES", "places"}, {SYNAPSE_QUERY_FLAGS_INTERNET, "SYNAPSE_QUERY_FLAGS_INTERNET", "internet"}, {SYNAPSE_QUERY_FLAGS_TEXT, "SYNAPSE_QUERY_FLAGS_TEXT", "text"}, {SYNAPSE_QUERY_FLAGS_CONTACTS, "SYNAPSE_QUERY_FLAGS_CONTACTS", "contacts"}, {SYNAPSE_QUERY_FLAGS_ALL, "SYNAPSE_QUERY_FLAGS_ALL", "all"}, {SYNAPSE_QUERY_FLAGS_LOCAL_CONTENT, "SYNAPSE_QUERY_FLAGS_LOCAL_CONTENT", "local-content"}, {0, NULL, NULL}};
		GType synapse_query_flags_type_id;
		synapse_query_flags_type_id = g_flags_register_static ("SynapseQueryFlags", values);
		g_once_init_leave (&synapse_query_flags_type_id__volatile, synapse_query_flags_type_id);
	}
	return synapse_query_flags_type_id__volatile;
}

GType
synapse_matcher_flags_get_type (void)
{
	static volatile gsize synapse_matcher_flags_type_id__volatile = 0;
	if (g_once_init_enter (&synapse_matcher_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{SYNAPSE_MATCHER_FLAGS_NO_REVERSED, "SYNAPSE_MATCHER_FLAGS_NO_REVERSED", "no-reversed"}, {SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING, "SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING", "no-substring"}, {SYNAPSE_MATCHER_FLAGS_NO_PARTIAL, "SYNAPSE_MATCHER_FLAGS_NO_PARTIAL", "no-partial"}, {SYNAPSE_MATCHER_FLAGS_NO_FUZZY, "SYNAPSE_MATCHER_FLAGS_NO_FUZZY", "no-fuzzy"}, {0, NULL, NULL}};
		GType synapse_matcher_flags_type_id;
		synapse_matcher_flags_type_id = g_flags_register_static ("SynapseMatcherFlags", values);
		g_once_init_leave (&synapse_matcher_flags_type_id__volatile, synapse_matcher_flags_type_id);
	}
	return synapse_matcher_flags_type_id__volatile;
}

void
synapse_query_init (SynapseQuery *self,
                    guint query_id,
                    const gchar* query,
                    SynapseQueryFlags flags,
                    guint num_results)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 95 "query.vala"
	g_return_if_fail (query != NULL);
#line 95 "query.vala"
	memset (self, 0, sizeof (SynapseQuery));
#line 100 "query.vala"
	(*self).query_id = query_id;
#line 101 "query.vala"
	_tmp0_ = g_strdup (query);
#line 101 "query.vala"
	_g_free0 ((*self).query_string);
#line 101 "query.vala"
	(*self).query_string = _tmp0_;
#line 102 "query.vala"
	_tmp1_ = g_utf8_casefold (query, (gssize) -1);
#line 102 "query.vala"
	_g_free0 ((*self).query_string_folded);
#line 102 "query.vala"
	(*self).query_string_folded = _tmp1_;
#line 103 "query.vala"
	(*self).query_type = flags;
#line 104 "query.vala"
	(*self).max_results = num_results;
#line 198 "query.c"
}

gboolean
synapse_query_is_cancelled (SynapseQuery *self)
{
	GCancellable* _tmp0_;
	gboolean result = FALSE;
#line 109 "query.vala"
	_tmp0_ = (*self).cancellable;
#line 109 "query.vala"
	result = g_cancellable_is_cancelled (_tmp0_);
#line 109 "query.vala"
	return result;
#line 212 "query.c"
}

void
synapse_query_check_cancellable (SynapseQuery *self,
                                 GError** error)
{
	GCancellable* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 114 "query.vala"
	_tmp0_ = (*self).cancellable;
#line 114 "query.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 225 "query.c"
		GError* _tmp1_;
#line 116 "query.vala"
		_tmp1_ = g_error_new_literal (SYNAPSE_SEARCH_ERROR, SYNAPSE_SEARCH_ERROR_SEARCH_CANCELLED, "Cancelled");
#line 116 "query.vala"
		_inner_error0_ = _tmp1_;
#line 116 "query.vala"
		if (_inner_error0_->domain == SYNAPSE_SEARCH_ERROR) {
#line 116 "query.vala"
			g_propagate_error (error, _inner_error0_);
#line 116 "query.vala"
			return;
#line 237 "query.c"
		} else {
#line 116 "query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "query.vala"
			g_clear_error (&_inner_error0_);
#line 116 "query.vala"
			return;
#line 245 "query.c"
		}
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 268 "query.c"
}

static void
_vala_array_add6 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 177 "query.vala"
	if ((*length) == (*size)) {
#line 177 "query.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 177 "query.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 283 "query.c"
	}
#line 177 "query.vala"
	(*array)[(*length)++] = value;
#line 177 "query.vala"
	(*array)[*length] = NULL;
#line 289 "query.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 303 "query.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 307 "query.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 313 "query.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 318 "query.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 324 "query.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 328 "query.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 332 "query.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 336 "query.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 340 "query.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 344 "query.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 358 "query.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 367 "query.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 374 "query.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 380 "query.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 388 "query.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 392 "query.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 398 "query.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 403 "query.c"
						const gchar* _tmp9_;
#line 1154 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1154 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 409 "query.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 413 "query.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 417 "query.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 423 "query.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1155 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 429 "query.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1155 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1155 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1155 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 441 "query.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 445 "query.c"
				}
#line 1155 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 449 "query.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		if (i == 0) {
#line 454 "query.c"
			gchar* _tmp15_;
#line 1158 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp15_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 462 "query.c"
		}
#line 1160 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1161 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1161 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1163 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1163 "glib-2.0.vapi"
		res = _tmp18_;
#line 1164 "glib-2.0.vapi"
		_tmp19_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp21_;
#line 484 "query.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp22_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 493 "query.c"
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp22_) {
#line 502 "query.c"
					gint _tmp23_;
#line 1165 "glib-2.0.vapi"
					_tmp23_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp23_ + 1;
#line 508 "query.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 516 "query.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp24_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp25_;
#line 1167 "glib-2.0.vapi"
				_tmp27_ = str_array[i];
#line 1167 "glib-2.0.vapi"
				if (_tmp27_ != NULL) {
#line 528 "query.c"
					const gchar* _tmp28_;
#line 1167 "glib-2.0.vapi"
					_tmp28_ = str_array[i];
#line 1167 "glib-2.0.vapi"
					_tmp26_ = (const gchar*) _tmp28_;
#line 534 "query.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp26_ = "";
#line 538 "query.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp29_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp30_;
#line 546 "query.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp31_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp31_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 557 "query.c"
	} else {
		gchar* _tmp32_;
#line 1172 "glib-2.0.vapi"
		_tmp32_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp32_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 566 "query.c"
	}
}

static void
_vala_array_add7 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 249 "query.vala"
	if ((*length) == (*size)) {
#line 249 "query.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 249 "query.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 582 "query.c"
	}
#line 249 "query.vala"
	(*array)[(*length)++] = value;
#line 249 "query.vala"
	(*array)[*length] = NULL;
#line 588 "query.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 285 "query.vala"
	return self ? g_object_ref (self) : NULL;
#line 596 "query.c"
}

static gint
__lambda5_ (GeeMapEntry* a,
            GeeMapEntry* b)
{
	GeeMapEntry* e1 = NULL;
	GeeMapEntry* e2 = NULL;
	gconstpointer _tmp0_;
	gint _tmp1_;
	gconstpointer _tmp2_;
	gint _tmp3_;
	gint result = 0;
#line 287 "query.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 287 "query.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 288 "query.vala"
	e1 = G_TYPE_CHECK_INSTANCE_CAST (a, GEE_MAP_TYPE_ENTRY, GeeMapEntry);
#line 289 "query.vala"
	e2 = G_TYPE_CHECK_INSTANCE_CAST (b, GEE_MAP_TYPE_ENTRY, GeeMapEntry);
#line 290 "query.vala"
	_tmp0_ = gee_map_entry_get_value (e2);
#line 290 "query.vala"
	_tmp1_ = _tmp0_;
#line 290 "query.vala"
	_tmp2_ = gee_map_entry_get_value (e1);
#line 290 "query.vala"
	_tmp3_ = _tmp2_;
#line 290 "query.vala"
	result = ((gint) ((gintptr) _tmp1_)) - ((gint) ((gintptr) _tmp3_));
#line 290 "query.vala"
	return result;
#line 630 "query.c"
}

static gint
___lambda5__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda5_ ((GeeMapEntry*) a, (GeeMapEntry*) b);
#line 287 "query.vala"
	return result;
#line 642 "query.c"
}

GeeList*
synapse_query_get_matchers_for_query (const gchar* query,
                                      SynapseMatcherFlags match_flags,
                                      GRegexCompileFlags flags)
{
	GeeHashMap* results = NULL;
	GeeHashMap* _tmp0_;
	gchar* stripped_query = NULL;
	gchar* _tmp1_;
	gchar* escaped_query = NULL;
	gchar* _tmp2_;
	GRegex* re = NULL;
	gchar** individual_words = NULL;
	gchar** _tmp24_;
	gchar** _tmp25_;
	gint individual_words_length1;
	gint _individual_words_size_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar** individual_chars = NULL;
	gchar** _tmp83_;
	gchar** _tmp84_;
	gint individual_chars_length1;
	gint _individual_chars_size_;
	gchar** escaped_chars = NULL;
	gchar** _tmp85_;
	gint escaped_chars_length1;
	gint _escaped_chars_size_;
	gchar** _tmp86_;
	gint _tmp86__length1;
	gboolean _tmp90_ = FALSE;
	gboolean _tmp91_ = FALSE;
	gboolean _tmp104_ = FALSE;
	GeeArrayList* sorted_results = NULL;
	GeeArrayList* _tmp116_;
	GeeSet* entries = NULL;
	GeeSet* _tmp117_;
	GeeSet* _tmp118_;
	GeeSet* _tmp119_;
	GError* _inner_error0_ = NULL;
	GeeList* result = NULL;
#line 120 "query.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 138 "query.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_REGEX, (GBoxedCopyFunc) g_regex_ref, (GDestroyNotify) g_regex_unref, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 138 "query.vala"
	results = _tmp0_;
#line 139 "query.vala"
	_tmp1_ = string_strip (query);
#line 139 "query.vala"
	stripped_query = _tmp1_;
#line 140 "query.vala"
	_tmp2_ = g_regex_escape_string (stripped_query, -1);
#line 140 "query.vala"
	escaped_query = _tmp2_;
#line 700 "query.c"
	{
		GRegex* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GRegex* _tmp6_;
		GRegex* _tmp7_;
		GRegex* _tmp8_;
		GRegex* _tmp9_;
#line 145 "query.vala"
		_tmp4_ = g_strdup_printf ("^(%s)$", escaped_query);
#line 145 "query.vala"
		_tmp5_ = _tmp4_;
#line 145 "query.vala"
		_tmp6_ = g_regex_new (_tmp5_, flags, 0, &_inner_error0_);
#line 145 "query.vala"
		_tmp7_ = _tmp6_;
#line 145 "query.vala"
		_g_free0 (_tmp5_);
#line 145 "query.vala"
		_tmp3_ = _tmp7_;
#line 145 "query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "query.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 725 "query.c"
				goto __catch18_g_regex_error;
			}
#line 145 "query.vala"
			_g_regex_unref0 (re);
#line 145 "query.vala"
			_g_free0 (escaped_query);
#line 145 "query.vala"
			_g_free0 (stripped_query);
#line 145 "query.vala"
			_g_object_unref0 (results);
#line 145 "query.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "query.vala"
			g_clear_error (&_inner_error0_);
#line 145 "query.vala"
			return NULL;
#line 742 "query.c"
		}
#line 145 "query.vala"
		_tmp8_ = _tmp3_;
#line 145 "query.vala"
		_tmp3_ = NULL;
#line 145 "query.vala"
		_g_regex_unref0 (re);
#line 145 "query.vala"
		re = _tmp8_;
#line 146 "query.vala"
		_tmp9_ = re;
#line 146 "query.vala"
		gee_abstract_map_set ((GeeAbstractMap*) results, _tmp9_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_HIGHEST)));
#line 143 "query.vala"
		_g_regex_unref0 (_tmp3_);
#line 758 "query.c"
	}
	goto __finally18;
	__catch18_g_regex_error:
	{
		GError* err = NULL;
#line 143 "query.vala"
		err = _inner_error0_;
#line 143 "query.vala"
		_inner_error0_ = NULL;
#line 143 "query.vala"
		_g_error_free0 (err);
#line 770 "query.c"
	}
	__finally18:
#line 143 "query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "query.vala"
		_g_regex_unref0 (re);
#line 143 "query.vala"
		_g_free0 (escaped_query);
#line 143 "query.vala"
		_g_free0 (stripped_query);
#line 143 "query.vala"
		_g_object_unref0 (results);
#line 143 "query.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "query.vala"
		g_clear_error (&_inner_error0_);
#line 143 "query.vala"
		return NULL;
#line 789 "query.c"
	}
	{
		GRegex* _tmp10_ = NULL;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GRegex* _tmp13_;
		GRegex* _tmp14_;
		GRegex* _tmp15_;
		GRegex* _tmp16_;
#line 154 "query.vala"
		_tmp11_ = g_strdup_printf ("^(%s)", escaped_query);
#line 154 "query.vala"
		_tmp12_ = _tmp11_;
#line 154 "query.vala"
		_tmp13_ = g_regex_new (_tmp12_, flags, 0, &_inner_error0_);
#line 154 "query.vala"
		_tmp14_ = _tmp13_;
#line 154 "query.vala"
		_g_free0 (_tmp12_);
#line 154 "query.vala"
		_tmp10_ = _tmp14_;
#line 154 "query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "query.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 815 "query.c"
				goto __catch19_g_regex_error;
			}
#line 154 "query.vala"
			_g_regex_unref0 (re);
#line 154 "query.vala"
			_g_free0 (escaped_query);
#line 154 "query.vala"
			_g_free0 (stripped_query);
#line 154 "query.vala"
			_g_object_unref0 (results);
#line 154 "query.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "query.vala"
			g_clear_error (&_inner_error0_);
#line 154 "query.vala"
			return NULL;
#line 832 "query.c"
		}
#line 154 "query.vala"
		_tmp15_ = _tmp10_;
#line 154 "query.vala"
		_tmp10_ = NULL;
#line 154 "query.vala"
		_g_regex_unref0 (re);
#line 154 "query.vala"
		re = _tmp15_;
#line 155 "query.vala"
		_tmp16_ = re;
#line 155 "query.vala"
		gee_abstract_map_set ((GeeAbstractMap*) results, _tmp16_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_EXCELLENT)));
#line 152 "query.vala"
		_g_regex_unref0 (_tmp10_);
#line 848 "query.c"
	}
	goto __finally19;
	__catch19_g_regex_error:
	{
		GError* err = NULL;
#line 152 "query.vala"
		err = _inner_error0_;
#line 152 "query.vala"
		_inner_error0_ = NULL;
#line 152 "query.vala"
		_g_error_free0 (err);
#line 860 "query.c"
	}
	__finally19:
#line 152 "query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "query.vala"
		_g_regex_unref0 (re);
#line 152 "query.vala"
		_g_free0 (escaped_query);
#line 152 "query.vala"
		_g_free0 (stripped_query);
#line 152 "query.vala"
		_g_object_unref0 (results);
#line 152 "query.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "query.vala"
		g_clear_error (&_inner_error0_);
#line 152 "query.vala"
		return NULL;
#line 879 "query.c"
	}
	{
		GRegex* _tmp17_ = NULL;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GRegex* _tmp20_;
		GRegex* _tmp21_;
		GRegex* _tmp22_;
		GRegex* _tmp23_;
#line 163 "query.vala"
		_tmp18_ = g_strdup_printf ("\\b(%s)", escaped_query);
#line 163 "query.vala"
		_tmp19_ = _tmp18_;
#line 163 "query.vala"
		_tmp20_ = g_regex_new (_tmp19_, flags, 0, &_inner_error0_);
#line 163 "query.vala"
		_tmp21_ = _tmp20_;
#line 163 "query.vala"
		_g_free0 (_tmp19_);
#line 163 "query.vala"
		_tmp17_ = _tmp21_;
#line 163 "query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "query.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 905 "query.c"
				goto __catch20_g_regex_error;
			}
#line 163 "query.vala"
			_g_regex_unref0 (re);
#line 163 "query.vala"
			_g_free0 (escaped_query);
#line 163 "query.vala"
			_g_free0 (stripped_query);
#line 163 "query.vala"
			_g_object_unref0 (results);
#line 163 "query.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 163 "query.vala"
			g_clear_error (&_inner_error0_);
#line 163 "query.vala"
			return NULL;
#line 922 "query.c"
		}
#line 163 "query.vala"
		_tmp22_ = _tmp17_;
#line 163 "query.vala"
		_tmp17_ = NULL;
#line 163 "query.vala"
		_g_regex_unref0 (re);
#line 163 "query.vala"
		re = _tmp22_;
#line 164 "query.vala"
		_tmp23_ = re;
#line 164 "query.vala"
		gee_abstract_map_set ((GeeAbstractMap*) results, _tmp23_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_VERY_GOOD)));
#line 161 "query.vala"
		_g_regex_unref0 (_tmp17_);
#line 938 "query.c"
	}
	goto __finally20;
	__catch20_g_regex_error:
	{
		GError* err = NULL;
#line 161 "query.vala"
		err = _inner_error0_;
#line 161 "query.vala"
		_inner_error0_ = NULL;
#line 161 "query.vala"
		_g_error_free0 (err);
#line 950 "query.c"
	}
	__finally20:
#line 161 "query.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "query.vala"
		_g_regex_unref0 (re);
#line 161 "query.vala"
		_g_free0 (escaped_query);
#line 161 "query.vala"
		_g_free0 (stripped_query);
#line 161 "query.vala"
		_g_object_unref0 (results);
#line 161 "query.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 161 "query.vala"
		g_clear_error (&_inner_error0_);
#line 161 "query.vala"
		return NULL;
#line 969 "query.c"
	}
#line 171 "query.vala"
	_tmp25_ = _tmp24_ = g_regex_split_simple ("\\s+", stripped_query, 0, 0);
#line 171 "query.vala"
	individual_words = _tmp25_;
#line 171 "query.vala"
	individual_words_length1 = _vala_array_length (_tmp24_);
#line 171 "query.vala"
	_individual_words_size_ = individual_words_length1;
#line 172 "query.vala"
	_tmp26_ = individual_words;
#line 172 "query.vala"
	_tmp26__length1 = individual_words_length1;
#line 172 "query.vala"
	if (_tmp26__length1 >= 2) {
#line 985 "query.c"
		gchar** escaped_words = NULL;
		gchar** _tmp27_;
		gint escaped_words_length1;
		gint _escaped_words_size_;
		gchar** _tmp28_;
		gint _tmp28__length1;
		gchar* pattern = NULL;
		gchar** _tmp32_;
		gint _tmp32__length1;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
#line 174 "query.vala"
		_tmp27_ = g_new0 (gchar*, 0 + 1);
#line 174 "query.vala"
		escaped_words = _tmp27_;
#line 174 "query.vala"
		escaped_words_length1 = 0;
#line 174 "query.vala"
		_escaped_words_size_ = escaped_words_length1;
#line 175 "query.vala"
		_tmp28_ = individual_words;
#line 175 "query.vala"
		_tmp28__length1 = individual_words_length1;
#line 1011 "query.c"
		{
			gchar** word_collection = NULL;
			gint word_collection_length1 = 0;
			gint _word_collection_size_ = 0;
			gint word_it = 0;
#line 175 "query.vala"
			word_collection = _tmp28_;
#line 175 "query.vala"
			word_collection_length1 = _tmp28__length1;
#line 175 "query.vala"
			for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
#line 1023 "query.c"
				const gchar* word = NULL;
#line 175 "query.vala"
				word = word_collection[word_it];
#line 1027 "query.c"
				{
					gchar** _tmp29_;
					gint _tmp29__length1;
					const gchar* _tmp30_;
					gchar* _tmp31_;
#line 177 "query.vala"
					_tmp29_ = escaped_words;
#line 177 "query.vala"
					_tmp29__length1 = escaped_words_length1;
#line 177 "query.vala"
					_tmp30_ = word;
#line 177 "query.vala"
					_tmp31_ = g_regex_escape_string (_tmp30_, -1);
#line 177 "query.vala"
					_vala_array_add6 (&escaped_words, &escaped_words_length1, &_escaped_words_size_, _tmp31_);
#line 1043 "query.c"
				}
			}
		}
#line 179 "query.vala"
		_tmp32_ = escaped_words;
#line 179 "query.vala"
		_tmp32__length1 = escaped_words_length1;
#line 179 "query.vala"
		_tmp33_ = _vala_g_strjoinv (").+\\b(", _tmp32_, (gint) _tmp32__length1);
#line 179 "query.vala"
		_tmp34_ = _tmp33_;
#line 179 "query.vala"
		_tmp35_ = g_strdup_printf ("\\b(%s)", _tmp34_);
#line 179 "query.vala"
		_tmp36_ = _tmp35_;
#line 179 "query.vala"
		_g_free0 (_tmp34_);
#line 179 "query.vala"
		pattern = _tmp36_;
#line 1063 "query.c"
		{
			GRegex* _tmp37_ = NULL;
			const gchar* _tmp38_;
			GRegex* _tmp39_;
			GRegex* _tmp40_;
			GRegex* _tmp41_;
#line 184 "query.vala"
			_tmp38_ = pattern;
#line 184 "query.vala"
			_tmp39_ = g_regex_new (_tmp38_, flags, 0, &_inner_error0_);
#line 184 "query.vala"
			_tmp37_ = _tmp39_;
#line 184 "query.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "query.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1080 "query.c"
					goto __catch21_g_regex_error;
				}
#line 184 "query.vala"
				_g_free0 (pattern);
#line 184 "query.vala"
				escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
#line 184 "query.vala"
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 184 "query.vala"
				_g_regex_unref0 (re);
#line 184 "query.vala"
				_g_free0 (escaped_query);
#line 184 "query.vala"
				_g_free0 (stripped_query);
#line 184 "query.vala"
				_g_object_unref0 (results);
#line 184 "query.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 184 "query.vala"
				g_clear_error (&_inner_error0_);
#line 184 "query.vala"
				return NULL;
#line 1103 "query.c"
			}
#line 184 "query.vala"
			_tmp40_ = _tmp37_;
#line 184 "query.vala"
			_tmp37_ = NULL;
#line 184 "query.vala"
			_g_regex_unref0 (re);
#line 184 "query.vala"
			re = _tmp40_;
#line 185 "query.vala"
			_tmp41_ = re;
#line 185 "query.vala"
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp41_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_GOOD)));
#line 182 "query.vala"
			_g_regex_unref0 (_tmp37_);
#line 1119 "query.c"
		}
		goto __finally21;
		__catch21_g_regex_error:
		{
			GError* err = NULL;
#line 182 "query.vala"
			err = _inner_error0_;
#line 182 "query.vala"
			_inner_error0_ = NULL;
#line 182 "query.vala"
			_g_error_free0 (err);
#line 1131 "query.c"
		}
		__finally21:
#line 182 "query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "query.vala"
			_g_free0 (pattern);
#line 182 "query.vala"
			escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
#line 182 "query.vala"
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 182 "query.vala"
			_g_regex_unref0 (re);
#line 182 "query.vala"
			_g_free0 (escaped_query);
#line 182 "query.vala"
			_g_free0 (stripped_query);
#line 182 "query.vala"
			_g_object_unref0 (results);
#line 182 "query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "query.vala"
			g_clear_error (&_inner_error0_);
#line 182 "query.vala"
			return NULL;
#line 1156 "query.c"
		}
#line 192 "query.vala"
		if (!((match_flags & SYNAPSE_MATCHER_FLAGS_NO_REVERSED) == SYNAPSE_MATCHER_FLAGS_NO_REVERSED)) {
#line 1160 "query.c"
			gchar** _tmp42_;
			gint _tmp42__length1;
#line 194 "query.vala"
			_tmp42_ = escaped_words;
#line 194 "query.vala"
			_tmp42__length1 = escaped_words_length1;
#line 194 "query.vala"
			if (_tmp42__length1 == 2) {
#line 1169 "query.c"
				gchar* reversed = NULL;
				gchar** _tmp43_;
				gint _tmp43__length1;
				const gchar* _tmp44_;
				gchar** _tmp45_;
				gint _tmp45__length1;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
#line 196 "query.vala"
				_tmp43_ = escaped_words;
#line 196 "query.vala"
				_tmp43__length1 = escaped_words_length1;
#line 196 "query.vala"
				_tmp44_ = _tmp43_[1];
#line 196 "query.vala"
				_tmp45_ = escaped_words;
#line 196 "query.vala"
				_tmp45__length1 = escaped_words_length1;
#line 196 "query.vala"
				_tmp46_ = _tmp45_[0];
#line 196 "query.vala"
				_tmp47_ = g_strjoin (").+\\b(", _tmp44_, _tmp46_, NULL, NULL);
#line 196 "query.vala"
				_tmp48_ = _tmp47_;
#line 196 "query.vala"
				_tmp49_ = g_strdup_printf ("\\b(%s)", _tmp48_);
#line 196 "query.vala"
				_tmp50_ = _tmp49_;
#line 196 "query.vala"
				_g_free0 (_tmp48_);
#line 196 "query.vala"
				reversed = _tmp50_;
#line 1205 "query.c"
				{
					GRegex* _tmp51_ = NULL;
					const gchar* _tmp52_;
					GRegex* _tmp53_;
					GRegex* _tmp54_;
					GRegex* _tmp55_;
#line 202 "query.vala"
					_tmp52_ = reversed;
#line 202 "query.vala"
					_tmp53_ = g_regex_new (_tmp52_, flags, 0, &_inner_error0_);
#line 202 "query.vala"
					_tmp51_ = _tmp53_;
#line 202 "query.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "query.vala"
						if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1222 "query.c"
							goto __catch22_g_regex_error;
						}
#line 202 "query.vala"
						_g_free0 (reversed);
#line 202 "query.vala"
						_g_free0 (pattern);
#line 202 "query.vala"
						escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
#line 202 "query.vala"
						individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 202 "query.vala"
						_g_regex_unref0 (re);
#line 202 "query.vala"
						_g_free0 (escaped_query);
#line 202 "query.vala"
						_g_free0 (stripped_query);
#line 202 "query.vala"
						_g_object_unref0 (results);
#line 202 "query.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "query.vala"
						g_clear_error (&_inner_error0_);
#line 202 "query.vala"
						return NULL;
#line 1247 "query.c"
					}
#line 202 "query.vala"
					_tmp54_ = _tmp51_;
#line 202 "query.vala"
					_tmp51_ = NULL;
#line 202 "query.vala"
					_g_regex_unref0 (re);
#line 202 "query.vala"
					re = _tmp54_;
#line 203 "query.vala"
					_tmp55_ = re;
#line 203 "query.vala"
					gee_abstract_map_set ((GeeAbstractMap*) results, _tmp55_, (gpointer) ((gintptr) ((gint) (SYNAPSE_MATCH_SCORE_GOOD - SYNAPSE_MATCH_SCORE_INCREMENT_MINOR))));
#line 200 "query.vala"
					_g_regex_unref0 (_tmp51_);
#line 1263 "query.c"
				}
				goto __finally22;
				__catch22_g_regex_error:
				{
					GError* err = NULL;
#line 200 "query.vala"
					err = _inner_error0_;
#line 200 "query.vala"
					_inner_error0_ = NULL;
#line 200 "query.vala"
					_g_error_free0 (err);
#line 1275 "query.c"
				}
				__finally22:
#line 200 "query.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "query.vala"
					_g_free0 (reversed);
#line 200 "query.vala"
					_g_free0 (pattern);
#line 200 "query.vala"
					escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
#line 200 "query.vala"
					individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 200 "query.vala"
					_g_regex_unref0 (re);
#line 200 "query.vala"
					_g_free0 (escaped_query);
#line 200 "query.vala"
					_g_free0 (stripped_query);
#line 200 "query.vala"
					_g_object_unref0 (results);
#line 200 "query.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 200 "query.vala"
					g_clear_error (&_inner_error0_);
#line 200 "query.vala"
					return NULL;
#line 1302 "query.c"
				}
#line 194 "query.vala"
				_g_free0 (reversed);
#line 1306 "query.c"
			} else {
				gchar* orred = NULL;
				gchar** _tmp56_;
				gint _tmp56__length1;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* any_order = NULL;
				gchar* _tmp61_;
#line 212 "query.vala"
				_tmp56_ = escaped_words;
#line 212 "query.vala"
				_tmp56__length1 = escaped_words_length1;
#line 212 "query.vala"
				_tmp57_ = _vala_g_strjoinv (")|(?:", _tmp56_, (gint) _tmp56__length1);
#line 212 "query.vala"
				_tmp58_ = _tmp57_;
#line 212 "query.vala"
				_tmp59_ = g_strdup_printf ("\\b((?:%s))", _tmp58_);
#line 212 "query.vala"
				_tmp60_ = _tmp59_;
#line 212 "query.vala"
				_g_free0 (_tmp58_);
#line 212 "query.vala"
				orred = _tmp60_;
#line 213 "query.vala"
				_tmp61_ = g_strdup ("");
#line 213 "query.vala"
				any_order = _tmp61_;
#line 1337 "query.c"
				{
					gint i = 0;
#line 214 "query.vala"
					i = 0;
#line 1342 "query.c"
					{
						gboolean _tmp62_ = FALSE;
#line 214 "query.vala"
						_tmp62_ = TRUE;
#line 214 "query.vala"
						while (TRUE) {
#line 1349 "query.c"
							gchar** _tmp64_;
							gint _tmp64__length1;
							gboolean is_last = FALSE;
							gchar** _tmp65_;
							gint _tmp65__length1;
							const gchar* _tmp66_;
							const gchar* _tmp67_;
							gchar* _tmp68_;
#line 214 "query.vala"
							if (!_tmp62_) {
#line 1360 "query.c"
								gint _tmp63_;
#line 214 "query.vala"
								_tmp63_ = i;
#line 214 "query.vala"
								i = _tmp63_ + 1;
#line 1366 "query.c"
							}
#line 214 "query.vala"
							_tmp62_ = FALSE;
#line 214 "query.vala"
							_tmp64_ = escaped_words;
#line 214 "query.vala"
							_tmp64__length1 = escaped_words_length1;
#line 214 "query.vala"
							if (!(i < _tmp64__length1)) {
#line 214 "query.vala"
								break;
#line 1378 "query.c"
							}
#line 216 "query.vala"
							_tmp65_ = escaped_words;
#line 216 "query.vala"
							_tmp65__length1 = escaped_words_length1;
#line 216 "query.vala"
							is_last = i == (_tmp65__length1 - 1);
#line 217 "query.vala"
							_tmp66_ = any_order;
#line 217 "query.vala"
							_tmp67_ = orred;
#line 217 "query.vala"
							_tmp68_ = g_strconcat (_tmp66_, _tmp67_, NULL);
#line 217 "query.vala"
							_g_free0 (any_order);
#line 217 "query.vala"
							any_order = _tmp68_;
#line 218 "query.vala"
							if (!is_last) {
#line 1398 "query.c"
								const gchar* _tmp69_;
								gchar* _tmp70_;
#line 218 "query.vala"
								_tmp69_ = any_order;
#line 218 "query.vala"
								_tmp70_ = g_strconcat (_tmp69_, ".+", NULL);
#line 218 "query.vala"
								_g_free0 (any_order);
#line 218 "query.vala"
								any_order = _tmp70_;
#line 1409 "query.c"
							}
						}
					}
				}
				{
					GRegex* _tmp71_ = NULL;
					const gchar* _tmp72_;
					GRegex* _tmp73_;
					GRegex* _tmp74_;
					GRegex* _tmp75_;
#line 222 "query.vala"
					_tmp72_ = any_order;
#line 222 "query.vala"
					_tmp73_ = g_regex_new (_tmp72_, flags, 0, &_inner_error0_);
#line 222 "query.vala"
					_tmp71_ = _tmp73_;
#line 222 "query.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "query.vala"
						if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1430 "query.c"
							goto __catch23_g_regex_error;
						}
#line 222 "query.vala"
						_g_free0 (any_order);
#line 222 "query.vala"
						_g_free0 (orred);
#line 222 "query.vala"
						_g_free0 (pattern);
#line 222 "query.vala"
						escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
#line 222 "query.vala"
						individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 222 "query.vala"
						_g_regex_unref0 (re);
#line 222 "query.vala"
						_g_free0 (escaped_query);
#line 222 "query.vala"
						_g_free0 (stripped_query);
#line 222 "query.vala"
						_g_object_unref0 (results);
#line 222 "query.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "query.vala"
						g_clear_error (&_inner_error0_);
#line 222 "query.vala"
						return NULL;
#line 1457 "query.c"
					}
#line 222 "query.vala"
					_tmp74_ = _tmp71_;
#line 222 "query.vala"
					_tmp71_ = NULL;
#line 222 "query.vala"
					_g_regex_unref0 (re);
#line 222 "query.vala"
					re = _tmp74_;
#line 223 "query.vala"
					_tmp75_ = re;
#line 223 "query.vala"
					gee_abstract_map_set ((GeeAbstractMap*) results, _tmp75_, (gpointer) ((gintptr) ((gint) (SYNAPSE_MATCH_SCORE_AVERAGE + SYNAPSE_MATCH_SCORE_INCREMENT_MINOR))));
#line 220 "query.vala"
					_g_regex_unref0 (_tmp71_);
#line 1473 "query.c"
				}
				goto __finally23;
				__catch23_g_regex_error:
				{
					GError* err = NULL;
#line 220 "query.vala"
					err = _inner_error0_;
#line 220 "query.vala"
					_inner_error0_ = NULL;
#line 220 "query.vala"
					_g_error_free0 (err);
#line 1485 "query.c"
				}
				__finally23:
#line 220 "query.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "query.vala"
					_g_free0 (any_order);
#line 220 "query.vala"
					_g_free0 (orred);
#line 220 "query.vala"
					_g_free0 (pattern);
#line 220 "query.vala"
					escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
#line 220 "query.vala"
					individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 220 "query.vala"
					_g_regex_unref0 (re);
#line 220 "query.vala"
					_g_free0 (escaped_query);
#line 220 "query.vala"
					_g_free0 (stripped_query);
#line 220 "query.vala"
					_g_object_unref0 (results);
#line 220 "query.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "query.vala"
					g_clear_error (&_inner_error0_);
#line 220 "query.vala"
					return NULL;
#line 1514 "query.c"
				}
#line 194 "query.vala"
				_g_free0 (any_order);
#line 194 "query.vala"
				_g_free0 (orred);
#line 1520 "query.c"
			}
		}
#line 172 "query.vala"
		_g_free0 (pattern);
#line 172 "query.vala"
		escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
#line 1527 "query.c"
	}
#line 232 "query.vala"
	if (!((match_flags & SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING) == SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING)) {
#line 1531 "query.c"
		{
			GRegex* _tmp76_ = NULL;
			gchar* _tmp77_;
			gchar* _tmp78_;
			GRegex* _tmp79_;
			GRegex* _tmp80_;
			GRegex* _tmp81_;
			GRegex* _tmp82_;
#line 236 "query.vala"
			_tmp77_ = g_strdup_printf ("(%s)", escaped_query);
#line 236 "query.vala"
			_tmp78_ = _tmp77_;
#line 236 "query.vala"
			_tmp79_ = g_regex_new (_tmp78_, flags, 0, &_inner_error0_);
#line 236 "query.vala"
			_tmp80_ = _tmp79_;
#line 236 "query.vala"
			_g_free0 (_tmp78_);
#line 236 "query.vala"
			_tmp76_ = _tmp80_;
#line 236 "query.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 236 "query.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1556 "query.c"
					goto __catch24_g_regex_error;
				}
#line 236 "query.vala"
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 236 "query.vala"
				_g_regex_unref0 (re);
#line 236 "query.vala"
				_g_free0 (escaped_query);
#line 236 "query.vala"
				_g_free0 (stripped_query);
#line 236 "query.vala"
				_g_object_unref0 (results);
#line 236 "query.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 236 "query.vala"
				g_clear_error (&_inner_error0_);
#line 236 "query.vala"
				return NULL;
#line 1575 "query.c"
			}
#line 236 "query.vala"
			_tmp81_ = _tmp76_;
#line 236 "query.vala"
			_tmp76_ = NULL;
#line 236 "query.vala"
			_g_regex_unref0 (re);
#line 236 "query.vala"
			re = _tmp81_;
#line 237 "query.vala"
			_tmp82_ = re;
#line 237 "query.vala"
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp82_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_BELOW_AVERAGE)));
#line 234 "query.vala"
			_g_regex_unref0 (_tmp76_);
#line 1591 "query.c"
		}
		goto __finally24;
		__catch24_g_regex_error:
		{
			GError* err = NULL;
#line 234 "query.vala"
			err = _inner_error0_;
#line 234 "query.vala"
			_inner_error0_ = NULL;
#line 234 "query.vala"
			_g_error_free0 (err);
#line 1603 "query.c"
		}
		__finally24:
#line 234 "query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "query.vala"
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 234 "query.vala"
			_g_regex_unref0 (re);
#line 234 "query.vala"
			_g_free0 (escaped_query);
#line 234 "query.vala"
			_g_free0 (stripped_query);
#line 234 "query.vala"
			_g_object_unref0 (results);
#line 234 "query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "query.vala"
			g_clear_error (&_inner_error0_);
#line 234 "query.vala"
			return NULL;
#line 1624 "query.c"
		}
	}
#line 245 "query.vala"
	_tmp84_ = _tmp83_ = g_regex_split_simple ("\\s*", query, 0, 0);
#line 245 "query.vala"
	individual_chars = _tmp84_;
#line 245 "query.vala"
	individual_chars_length1 = _vala_array_length (_tmp83_);
#line 245 "query.vala"
	_individual_chars_size_ = individual_chars_length1;
#line 246 "query.vala"
	_tmp85_ = g_new0 (gchar*, 0 + 1);
#line 246 "query.vala"
	escaped_chars = _tmp85_;
#line 246 "query.vala"
	escaped_chars_length1 = 0;
#line 246 "query.vala"
	_escaped_chars_size_ = escaped_chars_length1;
#line 247 "query.vala"
	_tmp86_ = individual_chars;
#line 247 "query.vala"
	_tmp86__length1 = individual_chars_length1;
#line 1647 "query.c"
	{
		gchar** word_collection = NULL;
		gint word_collection_length1 = 0;
		gint _word_collection_size_ = 0;
		gint word_it = 0;
#line 247 "query.vala"
		word_collection = _tmp86_;
#line 247 "query.vala"
		word_collection_length1 = _tmp86__length1;
#line 247 "query.vala"
		for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
#line 1659 "query.c"
			const gchar* word = NULL;
#line 247 "query.vala"
			word = word_collection[word_it];
#line 1663 "query.c"
			{
				gchar** _tmp87_;
				gint _tmp87__length1;
				const gchar* _tmp88_;
				gchar* _tmp89_;
#line 249 "query.vala"
				_tmp87_ = escaped_chars;
#line 249 "query.vala"
				_tmp87__length1 = escaped_chars_length1;
#line 249 "query.vala"
				_tmp88_ = word;
#line 249 "query.vala"
				_tmp89_ = g_regex_escape_string (_tmp88_, -1);
#line 249 "query.vala"
				_vala_array_add7 (&escaped_chars, &escaped_chars_length1, &_escaped_chars_size_, _tmp89_);
#line 1679 "query.c"
			}
		}
	}
#line 253 "query.vala"
	if (!((match_flags & SYNAPSE_MATCHER_FLAGS_NO_PARTIAL) == SYNAPSE_MATCHER_FLAGS_NO_PARTIAL)) {
#line 1685 "query.c"
		gchar** _tmp92_;
		gint _tmp92__length1;
#line 254 "query.vala"
		_tmp92_ = individual_words;
#line 254 "query.vala"
		_tmp92__length1 = individual_words_length1;
#line 254 "query.vala"
		_tmp91_ = _tmp92__length1 == 1;
#line 1694 "query.c"
	} else {
#line 253 "query.vala"
		_tmp91_ = FALSE;
#line 1698 "query.c"
	}
#line 253 "query.vala"
	if (_tmp91_) {
#line 1702 "query.c"
		gchar** _tmp93_;
		gint _tmp93__length1;
#line 254 "query.vala"
		_tmp93_ = individual_chars;
#line 254 "query.vala"
		_tmp93__length1 = individual_chars_length1;
#line 254 "query.vala"
		_tmp90_ = _tmp93__length1 <= 5;
#line 1711 "query.c"
	} else {
#line 253 "query.vala"
		_tmp90_ = FALSE;
#line 1715 "query.c"
	}
#line 253 "query.vala"
	if (_tmp90_) {
#line 1719 "query.c"
		gchar* pattern = NULL;
		gchar** _tmp94_;
		gint _tmp94__length1;
		gchar* _tmp95_;
		gchar* _tmp96_;
		gchar* _tmp97_;
		gchar* _tmp98_;
#line 256 "query.vala"
		_tmp94_ = escaped_chars;
#line 256 "query.vala"
		_tmp94__length1 = escaped_chars_length1;
#line 256 "query.vala"
		_tmp95_ = _vala_g_strjoinv (").+\\b(", _tmp94_, (gint) _tmp94__length1);
#line 256 "query.vala"
		_tmp96_ = _tmp95_;
#line 256 "query.vala"
		_tmp97_ = g_strdup_printf ("\\b(%s)", _tmp96_);
#line 256 "query.vala"
		_tmp98_ = _tmp97_;
#line 256 "query.vala"
		_g_free0 (_tmp96_);
#line 256 "query.vala"
		pattern = _tmp98_;
#line 1743 "query.c"
		{
			GRegex* _tmp99_ = NULL;
			const gchar* _tmp100_;
			GRegex* _tmp101_;
			GRegex* _tmp102_;
			GRegex* _tmp103_;
#line 260 "query.vala"
			_tmp100_ = pattern;
#line 260 "query.vala"
			_tmp101_ = g_regex_new (_tmp100_, flags, 0, &_inner_error0_);
#line 260 "query.vala"
			_tmp99_ = _tmp101_;
#line 260 "query.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 260 "query.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1760 "query.c"
					goto __catch25_g_regex_error;
				}
#line 260 "query.vala"
				_g_free0 (pattern);
#line 260 "query.vala"
				escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
#line 260 "query.vala"
				individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
#line 260 "query.vala"
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 260 "query.vala"
				_g_regex_unref0 (re);
#line 260 "query.vala"
				_g_free0 (escaped_query);
#line 260 "query.vala"
				_g_free0 (stripped_query);
#line 260 "query.vala"
				_g_object_unref0 (results);
#line 260 "query.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 260 "query.vala"
				g_clear_error (&_inner_error0_);
#line 260 "query.vala"
				return NULL;
#line 1785 "query.c"
			}
#line 260 "query.vala"
			_tmp102_ = _tmp99_;
#line 260 "query.vala"
			_tmp99_ = NULL;
#line 260 "query.vala"
			_g_regex_unref0 (re);
#line 260 "query.vala"
			re = _tmp102_;
#line 261 "query.vala"
			_tmp103_ = re;
#line 261 "query.vala"
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp103_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_ABOVE_AVERAGE)));
#line 258 "query.vala"
			_g_regex_unref0 (_tmp99_);
#line 1801 "query.c"
		}
		goto __finally25;
		__catch25_g_regex_error:
		{
			GError* err = NULL;
#line 258 "query.vala"
			err = _inner_error0_;
#line 258 "query.vala"
			_inner_error0_ = NULL;
#line 258 "query.vala"
			_g_error_free0 (err);
#line 1813 "query.c"
		}
		__finally25:
#line 258 "query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "query.vala"
			_g_free0 (pattern);
#line 258 "query.vala"
			escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
#line 258 "query.vala"
			individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
#line 258 "query.vala"
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 258 "query.vala"
			_g_regex_unref0 (re);
#line 258 "query.vala"
			_g_free0 (escaped_query);
#line 258 "query.vala"
			_g_free0 (stripped_query);
#line 258 "query.vala"
			_g_object_unref0 (results);
#line 258 "query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "query.vala"
			g_clear_error (&_inner_error0_);
#line 258 "query.vala"
			return NULL;
#line 1840 "query.c"
		}
#line 253 "query.vala"
		_g_free0 (pattern);
#line 1844 "query.c"
	}
#line 268 "query.vala"
	if (!((match_flags & SYNAPSE_MATCHER_FLAGS_NO_FUZZY) == SYNAPSE_MATCHER_FLAGS_NO_FUZZY)) {
#line 1848 "query.c"
		gchar** _tmp105_;
		gint _tmp105__length1;
#line 268 "query.vala"
		_tmp105_ = escaped_chars;
#line 268 "query.vala"
		_tmp105__length1 = escaped_chars_length1;
#line 268 "query.vala"
		_tmp104_ = _tmp105__length1 > 0;
#line 1857 "query.c"
	} else {
#line 268 "query.vala"
		_tmp104_ = FALSE;
#line 1861 "query.c"
	}
#line 268 "query.vala"
	if (_tmp104_) {
#line 1865 "query.c"
		gchar* pattern = NULL;
		gchar** _tmp106_;
		gint _tmp106__length1;
		gchar* _tmp107_;
		gchar* _tmp108_;
		gchar* _tmp109_;
		gchar* _tmp110_;
#line 270 "query.vala"
		_tmp106_ = escaped_chars;
#line 270 "query.vala"
		_tmp106__length1 = escaped_chars_length1;
#line 270 "query.vala"
		_tmp107_ = _vala_g_strjoinv (").*(", _tmp106_, (gint) _tmp106__length1);
#line 270 "query.vala"
		_tmp108_ = _tmp107_;
#line 270 "query.vala"
		_tmp109_ = g_strdup_printf ("\\b(%s)", _tmp108_);
#line 270 "query.vala"
		_tmp110_ = _tmp109_;
#line 270 "query.vala"
		_g_free0 (_tmp108_);
#line 270 "query.vala"
		pattern = _tmp110_;
#line 1889 "query.c"
		{
			GRegex* _tmp111_ = NULL;
			const gchar* _tmp112_;
			GRegex* _tmp113_;
			GRegex* _tmp114_;
			GRegex* _tmp115_;
#line 274 "query.vala"
			_tmp112_ = pattern;
#line 274 "query.vala"
			_tmp113_ = g_regex_new (_tmp112_, flags, 0, &_inner_error0_);
#line 274 "query.vala"
			_tmp111_ = _tmp113_;
#line 274 "query.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "query.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1906 "query.c"
					goto __catch26_g_regex_error;
				}
#line 274 "query.vala"
				_g_free0 (pattern);
#line 274 "query.vala"
				escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
#line 274 "query.vala"
				individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
#line 274 "query.vala"
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 274 "query.vala"
				_g_regex_unref0 (re);
#line 274 "query.vala"
				_g_free0 (escaped_query);
#line 274 "query.vala"
				_g_free0 (stripped_query);
#line 274 "query.vala"
				_g_object_unref0 (results);
#line 274 "query.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 274 "query.vala"
				g_clear_error (&_inner_error0_);
#line 274 "query.vala"
				return NULL;
#line 1931 "query.c"
			}
#line 274 "query.vala"
			_tmp114_ = _tmp111_;
#line 274 "query.vala"
			_tmp111_ = NULL;
#line 274 "query.vala"
			_g_regex_unref0 (re);
#line 274 "query.vala"
			re = _tmp114_;
#line 275 "query.vala"
			_tmp115_ = re;
#line 275 "query.vala"
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp115_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_POOR)));
#line 272 "query.vala"
			_g_regex_unref0 (_tmp111_);
#line 1947 "query.c"
		}
		goto __finally26;
		__catch26_g_regex_error:
		{
			GError* err = NULL;
#line 272 "query.vala"
			err = _inner_error0_;
#line 272 "query.vala"
			_inner_error0_ = NULL;
#line 272 "query.vala"
			_g_error_free0 (err);
#line 1959 "query.c"
		}
		__finally26:
#line 272 "query.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "query.vala"
			_g_free0 (pattern);
#line 272 "query.vala"
			escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
#line 272 "query.vala"
			individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
#line 272 "query.vala"
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 272 "query.vala"
			_g_regex_unref0 (re);
#line 272 "query.vala"
			_g_free0 (escaped_query);
#line 272 "query.vala"
			_g_free0 (stripped_query);
#line 272 "query.vala"
			_g_object_unref0 (results);
#line 272 "query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 272 "query.vala"
			g_clear_error (&_inner_error0_);
#line 272 "query.vala"
			return NULL;
#line 1986 "query.c"
		}
#line 268 "query.vala"
		_g_free0 (pattern);
#line 1990 "query.c"
	}
#line 282 "query.vala"
	_tmp116_ = gee_array_list_new (GEE_MAP_TYPE_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 282 "query.vala"
	sorted_results = _tmp116_;
#line 283 "query.vala"
	_tmp117_ = gee_abstract_map_get_entries ((GeeAbstractMap*) results);
#line 283 "query.vala"
	_tmp118_ = _tmp117_;
#line 283 "query.vala"
	entries = _tmp118_;
#line 285 "query.vala"
	_tmp119_ = _g_object_ref0 (entries);
#line 285 "query.vala"
	g_object_set_data_full ((GObject*) sorted_results, "entries-ref", _tmp119_, g_object_unref);
#line 286 "query.vala"
	gee_array_list_add_all (sorted_results, (GeeCollection*) entries);
#line 287 "query.vala"
	gee_list_sort ((GeeList*) sorted_results, ___lambda5__gcompare_data_func, NULL, NULL);
#line 293 "query.vala"
	result = (GeeList*) sorted_results;
#line 293 "query.vala"
	_g_object_unref0 (entries);
#line 293 "query.vala"
	escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
#line 293 "query.vala"
	individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
#line 293 "query.vala"
	individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
#line 293 "query.vala"
	_g_regex_unref0 (re);
#line 293 "query.vala"
	_g_free0 (escaped_query);
#line 293 "query.vala"
	_g_free0 (stripped_query);
#line 293 "query.vala"
	_g_object_unref0 (results);
#line 293 "query.vala"
	return result;
#line 2030 "query.c"
}

void
synapse_query_copy (const SynapseQuery* self,
                    SynapseQuery* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* _tmp5_;
	SynapseQueryFlags _tmp6_;
#line 86 "query.vala"
	_tmp0_ = (*self).query_string;
#line 86 "query.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 86 "query.vala"
	_g_free0 ((*dest).query_string);
#line 86 "query.vala"
	(*dest).query_string = _tmp1_;
#line 86 "query.vala"
	_tmp2_ = (*self).query_string_folded;
#line 86 "query.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 86 "query.vala"
	_g_free0 ((*dest).query_string_folded);
#line 86 "query.vala"
	(*dest).query_string_folded = _tmp3_;
#line 86 "query.vala"
	_tmp4_ = (*self).cancellable;
#line 86 "query.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 86 "query.vala"
	_g_object_unref0 ((*dest).cancellable);
#line 86 "query.vala"
	(*dest).cancellable = _tmp5_;
#line 86 "query.vala"
	_tmp6_ = (*self).query_type;
#line 86 "query.vala"
	(*dest).query_type = _tmp6_;
#line 86 "query.vala"
	(*dest).max_results = (*self).max_results;
#line 86 "query.vala"
	(*dest).query_id = (*self).query_id;
#line 2076 "query.c"
}

void
synapse_query_destroy (SynapseQuery* self)
{
#line 88 "query.vala"
	_g_free0 ((*self).query_string);
#line 89 "query.vala"
	_g_free0 ((*self).query_string_folded);
#line 90 "query.vala"
	_g_object_unref0 ((*self).cancellable);
#line 2088 "query.c"
}

SynapseQuery*
synapse_query_dup (const SynapseQuery* self)
{
	SynapseQuery* dup;
#line 86 "query.vala"
	dup = g_new0 (SynapseQuery, 1);
#line 86 "query.vala"
	synapse_query_copy (self, dup);
#line 86 "query.vala"
	return dup;
#line 2101 "query.c"
}

void
synapse_query_free (SynapseQuery* self)
{
#line 86 "query.vala"
	synapse_query_destroy (self);
#line 86 "query.vala"
	g_free (self);
#line 2111 "query.c"
}

GType
synapse_query_get_type (void)
{
	static volatile gsize synapse_query_type_id__volatile = 0;
	if (g_once_init_enter (&synapse_query_type_id__volatile)) {
		GType synapse_query_type_id;
		synapse_query_type_id = g_boxed_type_register_static ("SynapseQuery", (GBoxedCopyFunc) synapse_query_dup, (GBoxedFreeFunc) synapse_query_free);
		g_once_init_leave (&synapse_query_type_id__volatile, synapse_query_type_id);
	}
	return synapse_query_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
#line 239 "data-sink.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2133 "query.c"
		int i;
#line 239 "data-sink.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 239 "data-sink.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 239 "data-sink.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2141 "query.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
#line 239 "data-sink.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 239 "data-sink.vala"
	g_free (array);
#line 2156 "query.c"
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
#line 239 "data-sink.vala"
	if (array) {
#line 239 "data-sink.vala"
		while (((gpointer*) array)[length]) {
#line 239 "data-sink.vala"
			length++;
#line 2170 "query.c"
		}
	}
#line 239 "data-sink.vala"
	return length;
#line 2175 "query.c"
}

